笔试专题(七)

文章目录

乒乓球筐(哈希)

题目链接

题解

  1. 两个哈希表
    先统计第一个字符串中的字符个数,再统计第二个字符串中的字符个数,如果第一个字符串中的字符个数大于等于第二个字符串中的字符个数,返回true,否则返回false
  2. 用一个哈希表
    先统计第一个字符串中的字符个数,然后再减去第二个字符串中的字符个数,如果hash表中某个字符的个数小于0就说明该字符不在第一字符串中,而只在第二个字符串中,返回false,否则返回true

代码

cpp 复制代码
#include <iostream>
using namespace std;

int main()
{
    string s,t;
    while(cin >> s >> t)// 未知组数的输入
    {
        int hash[26] = {0};
        int n = t.size();
        
        int flag = 1;
        for(auto ch : s)
        {
            hash[ch - 'A']++;
        }
        for(int i = 0;i < n;i++)
        {
            hash[t[i] - 'A']--;
            if(hash[t[i] - 'A'] < 0) 
            {
                flag = 0;
                cout << "No" << '\n';
                break;
            } 
        }
        if(flag)
        cout << "Yes" << '\n';
    }

    return 0;
}

组队竞赛

题目链接

题解

  1. 排序 + 贪心
  2. 总和最大 -> 每个小组的分数最大 -> 那么第二个人的分数尽可能大
  3. 那就让第一个人最小,第三个人最大,第二个人次大

代码

cpp 复制代码
#include <iostream>
#include<algorithm>
#include<vector>
using namespace std;

int main()
{
    int n; 
    cin >> n;
    vector<int> ret(3*n);
    for(int i = 0;i < 3*n;i++) cin >> ret[i];

    sort(ret.begin(),ret.end());

    long long sum = 0;
    int count = n;
    for(int i = 3*n-2;i >= 0;i-=2)
    {
        if(count == 0) break;
        sum += ret[i];
        count--;
    }
    cout << sum << '\n';


    return 0;
}

删除相邻数字的最大分数(线性dp)

题目链接

题解

  1. 线性dp,可以转换为打家劫舍问题
  2. 让hash表的下标为数组中的值,hash表中的数据对应所有相同的下标的数之和
  3. 细节问题:可以让dp数组的长度为1e4 + 10,可以不用判断hash表中的最大的数为数组的长度,dp数组第0个值都初始化为0,因为原数组中没有0的值,返回选或者不选中dp数组的最大值,对应N-1下表中两个数组中的最大值
  4. 为什么可以转换为打家劫舍问题?
    因为数组中出现了相邻的数选或者不选,这个数选了下一个数就不能选

代码

cpp 复制代码
#include <iostream>
#include<vector>
using namespace std;

const int N = 1e4 + 10;
const int M = 1e5 + 10;
int ret[M];

int main()
{
    int hash[N] = { 0 };
    int n = 0;
    cin >> n;
    for (int i = 0; i < n; i++) cin >> ret[i];

    for (int i = 0; i < n; i++)
    {
        hash[ret[i]] += ret[i];
    }

    vector<int> f(N);// 选
    auto g = f;// 不选

    for (int i = 1; i < N; i++)
    {
        f[i] = g[i - 1] + hash[i];
        g[i] = max(g[i - 1], f[i - 1]);
    }

    cout << max(f[N - 1], g[N - 1]) << '\n';

    return 0;
}
相关推荐
Navigator_Z4 小时前
LeetCode //C - 1289. Minimum Falling Path Sum II
c语言·算法·leetcode
CCblandy4 小时前
令牌桶在 0.9 倍负载超发 19%、固定窗口边界放行 20 个:四种限流算法同构实测
后端·python·算法·性能优化·架构
mmmmath_35 小时前
LeetCode.104.二叉树的最大深度
数据结构·leetcode
YangYang9YangYan6 小时前
2027供应链计划校招:数学与应用数学专业如何把预测模型讲成业务决策?
人工智能·sql·算法
jsjzsl26 小时前
递归自改进系统(RSI)的本质是自发对称破缺:智能爆炸有界—— AI研发切记盲目投入
人工智能·python·算法
程序员清风6 小时前
最短路径算法:BFS、Dijkstra 与 Floyd
java·算法·宽度优先
梦帮科技6 小时前
Kali Linux Scapy 畸形报文构造学——深度解剖非法 TCP Flags 与反常序列号
linux·爬虫·神经网络·算法·数学建模·系统架构·模拟退火算法
171320330计算机毕设编程7 小时前
计算机毕业设计 基于YOLO改进算法的车辆特征识别系统设计与实现--lw
java·大数据·python·sql·算法
姜鱼问生7 小时前
Nginx gzip 压缩:一个配置让页面加载快 3 倍
后端·算法·架构